From: Dani Moncayo <dmoncayo@gmail.com>
To: Eli Zaretskii <eliz@gnu.org>
Cc: Emacs development discussions <emacs-devel@gnu.org>
Subject: Re: Building Emacs from a new MinGW environment
Date: Sat, 9 Nov 2013 15:47:28 +0100 [thread overview]
Message-ID: <CAH8Pv0gZYVJmQVWfwRSdx5Uh3ofERehJiOKeY65=+KSH-ncBRQ@mail.gmail.com> (raw)
In-Reply-To: <834n9hm87s.fsf@gnu.org>
[-- Attachment #1: Type: text/plain, Size: 1461 bytes --]
>> > In a nutshell, srcdir is now guaranteed to be in /d/foo/bar format,
>> > and should be edited into d:/foo/bar when it is placed in
>> > src/epaths.h. The job is to remove anything from top-level
>> > Makefile.in that is required for file names in format other than
>> > /d/foo/bar, and still allow using %emacs_dir% in
>> > '--enable-locallisppath=PATH' option to configure. So I think
>> > msys_to_w32 should stay intact, but msys_lisppath_to_w32 could be
>> > simplified.
>>
>> A more ambitious goal, IMO, would be to understand what is the problem
>> with doing every conversion of MSYS paths to native w32 format with
>> "pwd -W", so that the pattern-matching technique could be entirely
>> replaced with that simpler and more elegant one.
>
> That's a possibility, but note that "pwd -W" requires that you cd into
> the directory first, which might be a problem in some rare cases.
>
> Also msys_lisppath_to_w32 works on PATH-style directory lists, not on
> single directories, and some of those directories might not exist, or
> include %emacs_dir%, which will cause pwd to fail.
>
> If these difficulties can be overcome, I have nothing against using
> "pwd -W".
I'm attaching a patch that works for me, and I think fulfills the
above requirements.
It makes _all_ translations of paths to native MS-Windows format using
the "pwd -W" feature of the MSYS shell, which I think is the only
reliable way of doing such translations.
--
Dani Moncayo
[-- Attachment #2: msys-to-w32.diff --]
[-- Type: text/plain, Size: 8856 bytes --]
diff --git a/Makefile.in b/Makefile.in
index 984dcea..ed3aa8b 100644
--- a/Makefile.in
+++ b/Makefile.in
@@ -317,22 +317,9 @@ epaths-force: FRC
-e 's;\(#.*PATH_DOC\).*$$;\1 "${etcdocdir}";') && \
${srcdir}/build-aux/move-if-change epaths.h.$$$$ src/epaths.h
-# Convert MSYS-style /x/foo or Windows-style x:\foo file names
-# into x:/foo that Windows can grok.
-msys_to_w32=sed -e 's,\\\\,/,g' -e 's,^/\([A-Za-z]\)/,\1:/,'
-
-# Transform directory search path and its components. Original can
-# be MSYS or Windows style. Set path separator to ";", directory
-# separator to "/" and transform MSYS-style "/c/" to "c:/".
-# Remove empty path components and escape semicolons.
-msys_lisppath_to_w32=sed -e 's,\\\\,/,g' \
- -e 's,\(^\|[:;]\)\([A-Za-z]\):/,\1/\2/,g' \
- -e 's/:/;/g' -e 's,\(^\|;\)/\([A-Za-z]\)/,\1\2:/,g' \
- -e 's/;\+/;/g' -e 's/^;//' -e 's/;$$//' -e 's/;/\\\\;/g'
-
-# Replace "${prefix}" with '%emacs_dir%' (which expands to install
+# Replace "${w32prefix}" with '%emacs_dir%' (which expands to install
# directory at runtime).
-msys_prefix_subst=sed -e 's!\(^\|;\)'"$${prefixpattern}"'\([;/]\|$$\)!\1%emacs_dir%\2!g'
+msys_w32prefix_subst=sed -e 's!\(^\|;\)'"$${w32prefixpattern}"'\([;/]\|$$\)!\1%emacs_dir%\2!g'
# Quote Sed special characters (except backslash and newline) with
# a double backslash.
@@ -340,22 +327,21 @@ msys_sed_sh_escape=sed -e 's/[];$$*.^[]/\\\\&/g'
# The w32 build needs a slightly different editing, and it uses
# nt/epaths.nt as the template.
+#
# Use the value of ${locallisppath} supplied by `configure',
# to support the --enable-locallisppath argument.
#
-# When building with MinGW inside the MSYS tree, 'pwd' produces directories
-# relative to the root of the MSYS tree, e.g. '/home/user/foo' instead of
-# '/d/MSYS/home/user/foo'. If such a value of srcdir is written to
-# src/epaths.h, that causes temacs to fail, because, being a MinGW
-# program that knows nothing of MSYS root substitution, it cannot find
-# the data directory. "pwd -W" produces Windows-style 'd:/foo/bar'
-# absolute directory names, so we use it here to countermand that lossage.
+# In this case, the paths written to 'src/epaths.h' must be in native
+# MS-Windows format (e.g. 'c:/foo/bar'), because temacs is a MinGW
+# program that doesn't support MSYS-style paths (e.g. '/c/foo/bar' or
+# '/foo/bar').
epaths-force-w32: FRC
- @(w32srcdir=`cd "${srcdir}"; pwd -W | sed -e 's,^\([A-Za-z]\):,/\1,' | ${msys_to_w32}` ; \
- prefixpattern=`echo '${prefix}' | ${msys_to_w32} | ${msys_sed_sh_escape}` ; \
- locallisppath=`echo '${locallisppath}' | ${msys_lisppath_to_w32} | ${msys_prefix_subst}` ; \
+ @(w32srcdir=`${srcdir}/build-aux/msys-to-w32 "${srcdir}"`; \
+ w32prefix=`${srcdir}/build-aux/msys-to-w32 "${prefix}" N`; \
+ w32prefixpattern=`echo "${w32prefix}" | ${msys_sed_sh_escape}` ; \
+ w32locallisppath=`${srcdir}/build-aux/msys-to-w32 "${locallisppath}" N ":" "\\;" | ${msys_w32prefix_subst}` ; \
sed < ${srcdir}/nt/epaths.nt > epaths.h.$$$$ \
- -e 's;\(#.*PATH_SITELOADSEARCH\).*$$;\1 "'"$${locallisppath}"'";' \
+ -e 's;\(#.*PATH_SITELOADSEARCH\).*$$;\1 "'"$${w32locallisppath}"'";' \
-e '/^.*#/s/@VER@/${version}/g' \
-e '/^.*#/s/@CFG@/${configuration}/g' \
-e "/^.*#/s|@SRC@|$${w32srcdir}|g") && \
diff --git a/build-aux/msys-to-w32 b/build-aux/msys-to-w32
new file mode 100644
index 0000000..f8ae2d4
--- /dev/null
+++ b/build-aux/msys-to-w32
@@ -0,0 +1,188 @@
+#!/bin/sh
+# Take a list of MSYS-compatible paths and convert them to native
+# MS-Windows format.
+# Status is zero if successful, nonzero otherwise.
+
+VERSION='2013-11-09 10:48'; # UTC
+# The definition above must lie within the first 8 lines in order
+# for the Emacs time-stamp write hook (at end) to update it.
+# If you change this file with Emacs, please let the write hook
+# do its job. Otherwise, update this string manually.
+
+# Copyright (C) 2002-2013 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+usage="usage: $0 PATHLIST [MUSTEXIST] [SEPARATOR [SEPARATOR2]]"
+
+help="$usage
+ or: $0 OPTION
+
+Convert MSYS-compatible paths to MS-Windows native format.
+
+PATHLIST should be a list of paths separated by SEPARATOR. This list
+will be written to the standard output after performing the following
+transformations:
+1. Empty paths will be discarded.
+2. Backslashes will be replaced by forward slashed.
+3. Two consecutive slashes will be replaced by a single one.
+4. Each path will be translated to Windows-native format, using
+ forward slashes (e.g. 'c:/foo/bar'). This translated path will
+ never end with a slash.
+5. Ocurrences of SEPARATOR2 withing the paths will be escaped with
+ backslashes.
+6. Different paths will be separated with SEPARATOR2.
+
+If MUSTEXIST is 'Y' (or not supplied), then each path in PATHLIST must
+exists.
+
+If SEPARATOR is not supplied, PATHLIST will be regarded as a single
+path.
+
+If SEPARATOR2 is not supplied, it will take the same value as
+SEPARATOR.
+
+Options:
+ --help display this help and exit
+ --version output version information and exit
+
+Report bugs to <bug-gnu-emacs@gnu.org>."
+
+version=`expr "$VERSION" : '\([^ ]*\)'`
+version="msys-to-w32 $version
+Copyright (C) 2011 Free Software Foundation, Inc.
+License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
+This is free software: you are free to change and redistribute it.
+There is NO WARRANTY, to the extent permitted by law."
+
+for arg
+do
+ case $arg in
+ --help | --hel | --he | --h)
+ exec echo "$help" ;;
+ --version | --versio | --versi | --vers | --ver | --ve | --v)
+ exec echo "$version" ;;
+ --)
+ shift
+ break ;;
+ -*)
+ echo "$0: invalid option: $arg" >&2
+ exit 1 ;;
+ *)
+ break ;;
+ esac
+done
+
+{ test $# -ge 1 && test $# -le 4; } ||
+{ echo "$0: $usage" >&2; exit 1; }
+
+# Arguments
+pathlist=$1
+mustexist=${2:-Y}
+separator=$3
+separator2=${4:-${separator}}
+
+# Split pathlist into its path components
+if test -n "$separator"
+then
+ IFS=${separator} patharray=( $pathlist )
+else
+ patharray=( "$pathlist" )
+fi
+
+# Output pathlist
+pathlist2=""
+
+for p in "${patharray[@]}"
+do
+ # Skip empty paths
+ test "$p" = "" && continue
+
+ # Replace '\' with '/', '//' with '/' and remove the final slash
+ # (if any).
+ p=${p//"\\"/"/"}
+ p=${p//\/\//"/"}
+ test ${#p} -gt 1 && p=${p%"/"}
+
+ if test -d "$p"
+ then
+ # The path exists, so just translate it
+ p2=`cd "$p" && pwd -W`
+ else
+ # The path does not exists. So, try to guess the
+ # Windows-native translation
+
+ test "${mustexist}" = "Y" &&
+ { echo "$0: invalid path: $p" >&2; exit 1; }
+
+ # Look for the deepest existing directory in this path,
+ # testing with partial paths by removing one component from
+ # the right side in each iteration
+ IFS=/ pcomponents=( $p )
+ pa=$p
+
+ for (( i=${#pcomponents[@]}-1 ; i>=0 ; i-- ))
+ do
+
+ if test "${pcomponents[i]}" = ""
+ then
+ # The path component is empty. This can only mean
+ # that the path starts with "/" and all components
+ # have been stripped out already. So in this case
+ # "pa" must be set to the MSYS root directory
+ pa="/"
+ else
+ pa=${pa%"/${pcomponents[i]}"}
+ fi
+
+ if test -d "${pa}"
+ then
+
+ # Translate the existing part
+ p2=`cd "${pa}" && pwd -W`
+
+ # Remainder
+ pb="${p#${pa}}"
+
+ # Concatenate both parts (existing and remainder)
+ test "${p2}" = "/" || p2="${p2}/"
+ pb=${pb#/}
+ p2="${p2}${pb}"
+
+ break
+ fi
+
+ done
+
+ # If no existing directory was found, error out
+ test -e "${pa}" ||
+ { echo "$0: invalid path: ${p}" >&2; exit 1; }
+ fi
+
+ # Add this translated path to the translated pathlist
+ test "${pathlist2}" = "" || pathlist2="${pathlist2}${separator2}"
+ pathlist2="${pathlist2}${p2//${separator2}/\\${separator2}}"
+
+done
+
+# Write the translated pathlist to the standard output
+printf "${pathlist2}"
+
+## Local Variables:
+## eval: (add-hook 'write-file-functions 'time-stamp)
+## time-stamp-start: "VERSION='"
+## time-stamp-format: "%:y-%02m-%02d %02H:%02M"
+## time-stamp-time-zone: "UTC"
+## time-stamp-end: "'; # UTC"
+## End:
next prev parent reply other threads:[~2013-11-09 14:47 UTC|newest]
Thread overview: 70+ messages / expand[flat|nested] mbox.gz Atom feed top
2013-08-26 18:38 Building Emacs from a new MinGW environment Dani Moncayo
2013-08-26 19:38 ` Eli Zaretskii
2013-08-26 20:08 ` Dani Moncayo
2013-09-13 14:31 ` Dani Moncayo
2013-09-14 9:32 ` Eli Zaretskii
2013-09-14 9:41 ` Dani Moncayo
2013-09-14 10:07 ` Eli Zaretskii
2013-09-14 14:25 ` Dani Moncayo
2013-09-14 14:50 ` Eli Zaretskii
2013-09-14 15:42 ` Dani Moncayo
2013-09-14 16:10 ` Eli Zaretskii
2013-09-14 16:34 ` Dani Moncayo
2013-09-14 17:18 ` Eli Zaretskii
2013-09-14 19:57 ` Dani Moncayo
2013-09-14 20:56 ` Eli Zaretskii
2013-09-14 21:19 ` Dani Moncayo
2013-09-14 22:30 ` Dani Moncayo
2013-09-15 9:35 ` Eli Zaretskii
2013-09-15 9:28 ` Eli Zaretskii
2013-09-16 16:48 ` Dani Moncayo
2013-09-16 17:37 ` Eli Zaretskii
2013-09-16 19:25 ` Dani Moncayo
2013-09-16 19:40 ` Eli Zaretskii
2013-09-16 19:44 ` Dani Moncayo
2013-09-16 20:19 ` Eli Zaretskii
2013-09-17 7:16 ` Eli Zaretskii
2013-09-17 8:17 ` Dani Moncayo
2013-09-17 8:30 ` Eli Zaretskii
2013-09-17 16:09 ` Dani Moncayo
2013-09-17 16:17 ` Glenn Morris
2013-09-17 17:27 ` Eli Zaretskii
2013-09-17 20:29 ` Dani Moncayo
2013-09-18 7:46 ` Eli Zaretskii
2013-09-18 9:32 ` Dani Moncayo
2013-09-18 10:00 ` Eli Zaretskii
2013-09-18 10:38 ` Dani Moncayo
2013-09-18 11:21 ` Eli Zaretskii
2013-09-18 12:39 ` Dani Moncayo
2013-09-18 12:31 ` Dani Moncayo
2013-09-18 13:14 ` Eli Zaretskii
2013-09-18 16:51 ` Dani Moncayo
2013-09-18 19:20 ` Eli Zaretskii
2013-09-19 22:56 ` Dani Moncayo
2013-09-20 8:14 ` Eli Zaretskii
2013-09-20 9:29 ` Andy Moreton
2013-09-20 11:08 ` Dani Moncayo
2013-09-20 11:21 ` Eli Zaretskii
2013-09-20 12:22 ` Dani Moncayo
2013-09-20 12:30 ` Dani Moncayo
2013-09-20 13:16 ` Eli Zaretskii
2013-09-20 13:12 ` Eli Zaretskii
2013-09-20 14:12 ` Eli Zaretskii
2013-09-20 15:05 ` Dani Moncayo
2013-09-18 10:46 ` Andy Moreton
2013-09-18 11:24 ` Eli Zaretskii
2013-09-18 12:44 ` Sean Sieger
2013-09-18 13:16 ` Eli Zaretskii
2013-09-18 13:19 ` Sean Sieger
2013-09-18 14:33 ` Eli Zaretskii
2013-09-18 13:21 ` Andy Moreton
2013-09-18 14:45 ` Eli Zaretskii
2013-09-18 20:51 ` Andy Moreton
2013-09-19 8:45 ` Eli Zaretskii
2013-09-19 8:56 ` Dani Moncayo
2013-09-19 9:38 ` Eli Zaretskii
2013-09-19 10:04 ` Dani Moncayo
2013-09-19 10:11 ` Eli Zaretskii
2013-11-09 14:47 ` Dani Moncayo [this message]
2013-11-10 16:32 ` Dani Moncayo
2013-11-12 2:56 ` Glenn Morris
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: https://www.gnu.org/software/emacs/
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to='CAH8Pv0gZYVJmQVWfwRSdx5Uh3ofERehJiOKeY65=+KSH-ncBRQ@mail.gmail.com' \
--to=dmoncayo@gmail.com \
--cc=eliz@gnu.org \
--cc=emacs-devel@gnu.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://git.savannah.gnu.org/cgit/emacs.git
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).